From 6926cc1234853ccf3010a1e2625aafcf462ed60e Mon Sep 17 00:00:00 2001
From: Sebastian Ramacher <sebastian@ramacher.at>
Date: Tue, 14 Mar 2023 14:08:02 +0100
Subject: [PATCH] Fix invalid read in girara_node_free (fixes #17)

---
 girara/datastructures.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/girara/datastructures.c b/girara/datastructures.c
index cfffe00..1a9bbee 100644
--- a/girara/datastructures.c
+++ b/girara/datastructures.c
@@ -457,9 +457,10 @@ girara_node_free(girara_tree_node_t* node)
 
   GNode* childnode = node->node->children;
   while (childnode != NULL) {
+    GNode* nextnode = childnode->next;
     girara_tree_node_data_t* childnodedata = childnode->data;
     girara_node_free(childnodedata->node);
-    childnode = childnode->next;
+    childnode = nextnode;
   }
 
   g_node_destroy(node->node);
-- 
GitLab

